// -*- coding: utf-8 -*-
// Time-stamp: <particule.hpp   9 sep 2014 12:55:04> 

#ifndef PARTICULE_H
#define PARTICULE_H

// Random generation
#include <random>
#include <SFML/Graphics.hpp>

class Particule {
 public:
  // Constructors
  Particule(sf::Sprite* s, int xmax = 1, int ymax = 1) 
    : Particule(s, 0, 0, xmax, ymax) {}
  Particule(sf::Sprite* s, int xmin, int ymin, int xmax, int ymax);
  // Sprite getter
  sf::Sprite* getSprite() const { return sprite; }
  // X coordinate getter
  double getX() const { return x; }
  // Y coordinate getter
  double getY() const { return y; }
  // Class Container must access members to move particules
  friend class Container;
  friend class Bicontainer;

 private:
  double x;		// X coordinate
  double y;		// Y coordinate
  double dx;		// X speed
  double dy;		// Y speed
  sf::Sprite* sprite;	// Sprite to draw the particule
  // Shared objects for the random generation of particules coordinates
  static std::default_random_engine generator;
  static std::uniform_real_distribution<double> distribution;
};

#endif 
